<?php

namespace rdyescapia\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfOperationScheduleTypeOperationTime ArrayType
 * @subpackage Arrays
 */
class ArrayOfOperationScheduleTypeOperationTime extends AbstractStructArrayBase
{
    /**
     * The OperationTime
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \rdyescapia\StructType\OperationTime[]
     */
    public $OperationTime;
    /**
     * Constructor method for ArrayOfOperationScheduleTypeOperationTime
     * @uses ArrayOfOperationScheduleTypeOperationTime::setOperationTime()
     * @param \rdyescapia\StructType\OperationTime[] $operationTime
     */
    public function __construct(array $operationTime = array())
    {
        $this
            ->setOperationTime($operationTime);
    }
    /**
     * Get OperationTime value
     * @return \rdyescapia\StructType\OperationTime[]|null
     */
    public function getOperationTime()
    {
        return $this->OperationTime;
    }
    /**
     * This method is responsible for validating the values passed to the setOperationTime method
     * This method is willingly generated in order to preserve the one-line inline validation within the setOperationTime method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateOperationTimeForArrayConstraintsFromSetOperationTime(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfOperationScheduleTypeOperationTimeOperationTimeItem) {
            // validation for constraint: itemType
            if (!$arrayOfOperationScheduleTypeOperationTimeOperationTimeItem instanceof \rdyescapia\StructType\OperationTime) {
                $invalidValues[] = is_object($arrayOfOperationScheduleTypeOperationTimeOperationTimeItem) ? get_class($arrayOfOperationScheduleTypeOperationTimeOperationTimeItem) : sprintf('%s(%s)', gettype($arrayOfOperationScheduleTypeOperationTimeOperationTimeItem), var_export($arrayOfOperationScheduleTypeOperationTimeOperationTimeItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The OperationTime property can only contain items of type \rdyescapia\StructType\OperationTime, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set OperationTime value
     * @throws \InvalidArgumentException
     * @param \rdyescapia\StructType\OperationTime[] $operationTime
     * @return \rdyescapia\ArrayType\ArrayOfOperationScheduleTypeOperationTime
     */
    public function setOperationTime(array $operationTime = array())
    {
        // validation for constraint: array
        if ('' !== ($operationTimeArrayErrorMessage = self::validateOperationTimeForArrayConstraintsFromSetOperationTime($operationTime))) {
            throw new \InvalidArgumentException($operationTimeArrayErrorMessage, __LINE__);
        }
        $this->OperationTime = $operationTime;
        return $this;
    }
    /**
     * Add item to OperationTime value
     * @throws \InvalidArgumentException
     * @param \rdyescapia\StructType\OperationTime $item
     * @return \rdyescapia\ArrayType\ArrayOfOperationScheduleTypeOperationTime
     */
    public function addToOperationTime(\rdyescapia\StructType\OperationTime $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \rdyescapia\StructType\OperationTime) {
            throw new \InvalidArgumentException(sprintf('The OperationTime property can only contain items of type \rdyescapia\StructType\OperationTime, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->OperationTime[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \rdyescapia\StructType\OperationTime|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \rdyescapia\StructType\OperationTime|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \rdyescapia\StructType\OperationTime|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \rdyescapia\StructType\OperationTime|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \rdyescapia\StructType\OperationTime|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string OperationTime
     */
    public function getAttributeName()
    {
        return 'OperationTime';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \rdyescapia\ArrayType\ArrayOfOperationScheduleTypeOperationTime
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
