<?php

namespace rdyescapia\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfResGuestsTypeResGuest ArrayType
 * @subpackage Arrays
 */
class ArrayOfResGuestsTypeResGuest extends AbstractStructArrayBase
{
    /**
     * The ResGuest
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \rdyescapia\StructType\ResGuest[]
     */
    public $ResGuest;
    /**
     * Constructor method for ArrayOfResGuestsTypeResGuest
     * @uses ArrayOfResGuestsTypeResGuest::setResGuest()
     * @param \rdyescapia\StructType\ResGuest[] $resGuest
     */
    public function __construct(array $resGuest = array())
    {
        $this
            ->setResGuest($resGuest);
    }
    /**
     * Get ResGuest value
     * @return \rdyescapia\StructType\ResGuest[]|null
     */
    public function getResGuest()
    {
        return $this->ResGuest;
    }
    /**
     * This method is responsible for validating the values passed to the setResGuest method
     * This method is willingly generated in order to preserve the one-line inline validation within the setResGuest method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateResGuestForArrayConstraintsFromSetResGuest(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfResGuestsTypeResGuestResGuestItem) {
            // validation for constraint: itemType
            if (!$arrayOfResGuestsTypeResGuestResGuestItem instanceof \rdyescapia\StructType\ResGuest) {
                $invalidValues[] = is_object($arrayOfResGuestsTypeResGuestResGuestItem) ? get_class($arrayOfResGuestsTypeResGuestResGuestItem) : sprintf('%s(%s)', gettype($arrayOfResGuestsTypeResGuestResGuestItem), var_export($arrayOfResGuestsTypeResGuestResGuestItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ResGuest property can only contain items of type \rdyescapia\StructType\ResGuest, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ResGuest value
     * @throws \InvalidArgumentException
     * @param \rdyescapia\StructType\ResGuest[] $resGuest
     * @return \rdyescapia\ArrayType\ArrayOfResGuestsTypeResGuest
     */
    public function setResGuest(array $resGuest = array())
    {
        // validation for constraint: array
        if ('' !== ($resGuestArrayErrorMessage = self::validateResGuestForArrayConstraintsFromSetResGuest($resGuest))) {
            throw new \InvalidArgumentException($resGuestArrayErrorMessage, __LINE__);
        }
        $this->ResGuest = $resGuest;
        return $this;
    }
    /**
     * Add item to ResGuest value
     * @throws \InvalidArgumentException
     * @param \rdyescapia\StructType\ResGuest $item
     * @return \rdyescapia\ArrayType\ArrayOfResGuestsTypeResGuest
     */
    public function addToResGuest(\rdyescapia\StructType\ResGuest $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \rdyescapia\StructType\ResGuest) {
            throw new \InvalidArgumentException(sprintf('The ResGuest property can only contain items of type \rdyescapia\StructType\ResGuest, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ResGuest[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \rdyescapia\StructType\ResGuest|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \rdyescapia\StructType\ResGuest|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \rdyescapia\StructType\ResGuest|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \rdyescapia\StructType\ResGuest|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \rdyescapia\StructType\ResGuest|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ResGuest
     */
    public function getAttributeName()
    {
        return 'ResGuest';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \rdyescapia\ArrayType\ArrayOfResGuestsTypeResGuest
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
