<?php

namespace rdyescapia\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for BasicUnitInfo StructType
 * @subpackage Structs
 */
class BasicUnitInfo extends AbstractStructBase
{
    /**
     * The SendData
     * @var bool
     */
    public $SendData;
    /**
     * Constructor method for BasicUnitInfo
     * @uses BasicUnitInfo::setSendData()
     * @param bool $sendData
     */
    public function __construct($sendData = null)
    {
        $this
            ->setSendData($sendData);
    }
    /**
     * Get SendData value
     * @return bool|null
     */
    public function getSendData()
    {
        return $this->SendData;
    }
    /**
     * Set SendData value
     * @param bool $sendData
     * @return \rdyescapia\StructType\BasicUnitInfo
     */
    public function setSendData($sendData = null)
    {
        // validation for constraint: boolean
        if (!is_null($sendData) && !is_bool($sendData)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($sendData, true), gettype($sendData)), __LINE__);
        }
        $this->SendData = $sendData;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \rdyescapia\StructType\BasicUnitInfo
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
