<?php

namespace rdyescapia\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for EVRN_ResGlobalInfoType StructType
 * @subpackage Structs
 */
class EVRN_ResGlobalInfoType extends ResCommonDetailType
{
    /**
     * The UnitReservationIDs
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \rdyescapia\ArrayType\ArrayOfUnitReservationIDsTypeUnitReservationID
     */
    public $UnitReservationIDs;
    /**
     * The RoutingHops
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \rdyescapia\ArrayType\ArrayOfRoutingHopTypeRoutingHop
     */
    public $RoutingHops;
    /**
     * The Profiles
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \rdyescapia\ArrayType\ArrayOfProfilesTypeProfileInfo
     */
    public $Profiles;
    /**
     * The ServiceFee
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \rdyescapia\StructType\ServiceFeeType
     */
    public $ServiceFee;
    /**
     * Constructor method for EVRN_ResGlobalInfoType
     * @uses EVRN_ResGlobalInfoType::setUnitReservationIDs()
     * @uses EVRN_ResGlobalInfoType::setRoutingHops()
     * @uses EVRN_ResGlobalInfoType::setProfiles()
     * @uses EVRN_ResGlobalInfoType::setServiceFee()
     * @param \rdyescapia\ArrayType\ArrayOfUnitReservationIDsTypeUnitReservationID $unitReservationIDs
     * @param \rdyescapia\ArrayType\ArrayOfRoutingHopTypeRoutingHop $routingHops
     * @param \rdyescapia\ArrayType\ArrayOfProfilesTypeProfileInfo $profiles
     * @param \rdyescapia\StructType\ServiceFeeType $serviceFee
     */
    public function __construct(\rdyescapia\ArrayType\ArrayOfUnitReservationIDsTypeUnitReservationID $unitReservationIDs = null, \rdyescapia\ArrayType\ArrayOfRoutingHopTypeRoutingHop $routingHops = null, \rdyescapia\ArrayType\ArrayOfProfilesTypeProfileInfo $profiles = null, \rdyescapia\StructType\ServiceFeeType $serviceFee = null)
    {
        $this
            ->setUnitReservationIDs($unitReservationIDs)
            ->setRoutingHops($routingHops)
            ->setProfiles($profiles)
            ->setServiceFee($serviceFee);
    }
    /**
     * Get UnitReservationIDs value
     * @return \rdyescapia\ArrayType\ArrayOfUnitReservationIDsTypeUnitReservationID|null
     */
    public function getUnitReservationIDs()
    {
        return $this->UnitReservationIDs;
    }
    /**
     * Set UnitReservationIDs value
     * @param \rdyescapia\ArrayType\ArrayOfUnitReservationIDsTypeUnitReservationID $unitReservationIDs
     * @return \rdyescapia\StructType\EVRN_ResGlobalInfoType
     */
    public function setUnitReservationIDs(\rdyescapia\ArrayType\ArrayOfUnitReservationIDsTypeUnitReservationID $unitReservationIDs = null)
    {
        $this->UnitReservationIDs = $unitReservationIDs;
        return $this;
    }
    /**
     * Get RoutingHops value
     * @return \rdyescapia\ArrayType\ArrayOfRoutingHopTypeRoutingHop|null
     */
    public function getRoutingHops()
    {
        return $this->RoutingHops;
    }
    /**
     * Set RoutingHops value
     * @param \rdyescapia\ArrayType\ArrayOfRoutingHopTypeRoutingHop $routingHops
     * @return \rdyescapia\StructType\EVRN_ResGlobalInfoType
     */
    public function setRoutingHops(\rdyescapia\ArrayType\ArrayOfRoutingHopTypeRoutingHop $routingHops = null)
    {
        $this->RoutingHops = $routingHops;
        return $this;
    }
    /**
     * Get Profiles value
     * @return \rdyescapia\ArrayType\ArrayOfProfilesTypeProfileInfo|null
     */
    public function getProfiles()
    {
        return $this->Profiles;
    }
    /**
     * Set Profiles value
     * @param \rdyescapia\ArrayType\ArrayOfProfilesTypeProfileInfo $profiles
     * @return \rdyescapia\StructType\EVRN_ResGlobalInfoType
     */
    public function setProfiles(\rdyescapia\ArrayType\ArrayOfProfilesTypeProfileInfo $profiles = null)
    {
        $this->Profiles = $profiles;
        return $this;
    }
    /**
     * Get ServiceFee value
     * @return \rdyescapia\StructType\ServiceFeeType|null
     */
    public function getServiceFee()
    {
        return $this->ServiceFee;
    }
    /**
     * Set ServiceFee value
     * @param \rdyescapia\StructType\ServiceFeeType $serviceFee
     * @return \rdyescapia\StructType\EVRN_ResGlobalInfoType
     */
    public function setServiceFee(\rdyescapia\StructType\ServiceFeeType $serviceFee = null)
    {
        $this->ServiceFee = $serviceFee;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \rdyescapia\StructType\EVRN_ResGlobalInfoType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
