<?php

namespace rdyescapia\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ProfileInfo StructType
 * @subpackage Structs
 */
class ProfileInfo extends AbstractStructBase
{
    /**
     * The UniqueID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \rdyescapia\StructType\UniqueID_Type
     */
    public $UniqueID;
    /**
     * The Profile
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \rdyescapia\StructType\ProfileType
     */
    public $Profile;
    /**
     * Constructor method for ProfileInfo
     * @uses ProfileInfo::setUniqueID()
     * @uses ProfileInfo::setProfile()
     * @param \rdyescapia\StructType\UniqueID_Type $uniqueID
     * @param \rdyescapia\StructType\ProfileType $profile
     */
    public function __construct(\rdyescapia\StructType\UniqueID_Type $uniqueID = null, \rdyescapia\StructType\ProfileType $profile = null)
    {
        $this
            ->setUniqueID($uniqueID)
            ->setProfile($profile);
    }
    /**
     * Get UniqueID value
     * @return \rdyescapia\StructType\UniqueID_Type|null
     */
    public function getUniqueID()
    {
        return $this->UniqueID;
    }
    /**
     * Set UniqueID value
     * @param \rdyescapia\StructType\UniqueID_Type $uniqueID
     * @return \rdyescapia\StructType\ProfileInfo
     */
    public function setUniqueID(\rdyescapia\StructType\UniqueID_Type $uniqueID = null)
    {
        $this->UniqueID = $uniqueID;
        return $this;
    }
    /**
     * Get Profile value
     * @return \rdyescapia\StructType\ProfileType|null
     */
    public function getProfile()
    {
        return $this->Profile;
    }
    /**
     * Set Profile value
     * @param \rdyescapia\StructType\ProfileType $profile
     * @return \rdyescapia\StructType\ProfileInfo
     */
    public function setProfile(\rdyescapia\StructType\ProfileType $profile = null)
    {
        $this->Profile = $profile;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \rdyescapia\StructType\ProfileInfo
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
