<?php

namespace rdyescapia\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Promotions StructType
 * @subpackage Structs
 */
class Promotions extends AbstractStructBase
{
    /**
     * The SendPromotions
     * @var bool
     */
    public $SendPromotions;
    /**
     * Constructor method for Promotions
     * @uses Promotions::setSendPromotions()
     * @param bool $sendPromotions
     */
    public function __construct($sendPromotions = null)
    {
        $this
            ->setSendPromotions($sendPromotions);
    }
    /**
     * Get SendPromotions value
     * @return bool|null
     */
    public function getSendPromotions()
    {
        return $this->SendPromotions;
    }
    /**
     * Set SendPromotions value
     * @param bool $sendPromotions
     * @return \rdyescapia\StructType\Promotions
     */
    public function setSendPromotions($sendPromotions = null)
    {
        // validation for constraint: boolean
        if (!is_null($sendPromotions) && !is_bool($sendPromotions)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($sendPromotions, true), gettype($sendPromotions)), __LINE__);
        }
        $this->SendPromotions = $sendPromotions;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \rdyescapia\StructType\Promotions
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
