<?php

namespace rdyescapia\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PropertyManagerRequests StructType
 * @subpackage Structs
 */
class PropertyManagerRequests extends AbstractStructBase
{
    /**
     * The PropertyManagerRequest
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \rdyescapia\StructType\PropertyManagerRequestType[]
     */
    public $PropertyManagerRequest;
    /**
     * Constructor method for PropertyManagerRequests
     * @uses PropertyManagerRequests::setPropertyManagerRequest()
     * @param \rdyescapia\StructType\PropertyManagerRequestType[] $propertyManagerRequest
     */
    public function __construct(array $propertyManagerRequest = array())
    {
        $this
            ->setPropertyManagerRequest($propertyManagerRequest);
    }
    /**
     * Get PropertyManagerRequest value
     * @return \rdyescapia\StructType\PropertyManagerRequestType[]|null
     */
    public function getPropertyManagerRequest()
    {
        return $this->PropertyManagerRequest;
    }
    /**
     * This method is responsible for validating the values passed to the setPropertyManagerRequest method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPropertyManagerRequest method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePropertyManagerRequestForArrayConstraintsFromSetPropertyManagerRequest(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $propertyManagerRequestsPropertyManagerRequestItem) {
            // validation for constraint: itemType
            if (!$propertyManagerRequestsPropertyManagerRequestItem instanceof \rdyescapia\StructType\PropertyManagerRequestType) {
                $invalidValues[] = is_object($propertyManagerRequestsPropertyManagerRequestItem) ? get_class($propertyManagerRequestsPropertyManagerRequestItem) : sprintf('%s(%s)', gettype($propertyManagerRequestsPropertyManagerRequestItem), var_export($propertyManagerRequestsPropertyManagerRequestItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The PropertyManagerRequest property can only contain items of type \rdyescapia\StructType\PropertyManagerRequestType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set PropertyManagerRequest value
     * @throws \InvalidArgumentException
     * @param \rdyescapia\StructType\PropertyManagerRequestType[] $propertyManagerRequest
     * @return \rdyescapia\StructType\PropertyManagerRequests
     */
    public function setPropertyManagerRequest(array $propertyManagerRequest = array())
    {
        // validation for constraint: array
        if ('' !== ($propertyManagerRequestArrayErrorMessage = self::validatePropertyManagerRequestForArrayConstraintsFromSetPropertyManagerRequest($propertyManagerRequest))) {
            throw new \InvalidArgumentException($propertyManagerRequestArrayErrorMessage, __LINE__);
        }
        $this->PropertyManagerRequest = $propertyManagerRequest;
        return $this;
    }
    /**
     * Add item to PropertyManagerRequest value
     * @throws \InvalidArgumentException
     * @param \rdyescapia\StructType\PropertyManagerRequestType $item
     * @return \rdyescapia\StructType\PropertyManagerRequests
     */
    public function addToPropertyManagerRequest(\rdyescapia\StructType\PropertyManagerRequestType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \rdyescapia\StructType\PropertyManagerRequestType) {
            throw new \InvalidArgumentException(sprintf('The PropertyManagerRequest property can only contain items of type \rdyescapia\StructType\PropertyManagerRequestType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->PropertyManagerRequest[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \rdyescapia\StructType\PropertyManagerRequests
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
