<?php

namespace rdyescapia\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for UnitRate StructType
 * @subpackage Structs
 */
class UnitRate extends AbstractStructBase
{
    /**
     * The Rates
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \rdyescapia\ArrayType\ArrayOfEVRN_AmountType
     */
    public $Rates;
    /**
     * The UnitRateDescription
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \rdyescapia\StructType\ParagraphType
     */
    public $UnitRateDescription;
    /**
     * The Total
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \rdyescapia\StructType\TotalType
     */
    public $Total;
    /**
     * Constructor method for UnitRate
     * @uses UnitRate::setRates()
     * @uses UnitRate::setUnitRateDescription()
     * @uses UnitRate::setTotal()
     * @param \rdyescapia\ArrayType\ArrayOfEVRN_AmountType $rates
     * @param \rdyescapia\StructType\ParagraphType $unitRateDescription
     * @param \rdyescapia\StructType\TotalType $total
     */
    public function __construct(\rdyescapia\ArrayType\ArrayOfEVRN_AmountType $rates = null, \rdyescapia\StructType\ParagraphType $unitRateDescription = null, \rdyescapia\StructType\TotalType $total = null)
    {
        $this
            ->setRates($rates)
            ->setUnitRateDescription($unitRateDescription)
            ->setTotal($total);
    }
    /**
     * Get Rates value
     * @return \rdyescapia\ArrayType\ArrayOfEVRN_AmountType|null
     */
    public function getRates()
    {
        return $this->Rates;
    }
    /**
     * Set Rates value
     * @param \rdyescapia\ArrayType\ArrayOfEVRN_AmountType $rates
     * @return \rdyescapia\StructType\UnitRate
     */
    public function setRates(\rdyescapia\ArrayType\ArrayOfEVRN_AmountType $rates = null)
    {
        $this->Rates = $rates;
        return $this;
    }
    /**
     * Get UnitRateDescription value
     * @return \rdyescapia\StructType\ParagraphType|null
     */
    public function getUnitRateDescription()
    {
        return $this->UnitRateDescription;
    }
    /**
     * Set UnitRateDescription value
     * @param \rdyescapia\StructType\ParagraphType $unitRateDescription
     * @return \rdyescapia\StructType\UnitRate
     */
    public function setUnitRateDescription(\rdyescapia\StructType\ParagraphType $unitRateDescription = null)
    {
        $this->UnitRateDescription = $unitRateDescription;
        return $this;
    }
    /**
     * Get Total value
     * @return \rdyescapia\StructType\TotalType|null
     */
    public function getTotal()
    {
        return $this->Total;
    }
    /**
     * Set Total value
     * @param \rdyescapia\StructType\TotalType $total
     * @return \rdyescapia\StructType\UnitRate
     */
    public function setTotal(\rdyescapia\StructType\TotalType $total = null)
    {
        $this->Total = $total;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \rdyescapia\StructType\UnitRate
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
